<?php

namespace frontend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use frontend\models\OptionValues;

/**
 * OptionValuesSearch represents the model behind the search form about `frontend\models\OptionValues`.
 */
class OptionValuesSearch extends OptionValues
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['option_value_id', 'option_language_id', 'option_value_parent', 'option_user'], 'integer'],
            [['option_key', 'option_value_text'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = OptionValues::find();

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'option_value_id' => $this->option_value_id,
            'option_language_id' => $this->option_language_id,
            'option_value_parent' => $this->option_value_parent,
            'option_user' => $this->option_user,
        ]);

        $query->andFilterWhere(['like', 'option_key', $this->option_key])
            ->andFilterWhere(['like', 'option_value_text', $this->option_value_text]);

        return $dataProvider;
    }
}
